# -*- coding: utf-8 -*-
#
# File: Extensions/Install.py
#
# Copyright (c) 2007 atReal
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """atReal <contact@atreal.net> : Matthias Broquet (tiazma)"""
__docformat__ = 'plaintext'
__licence__ = 'GPL'

from Products.ARMailServices.config import *
from Products.ARMailServices.Extensions.utils import *
from Products.ARMailServices import *
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

def install_actions(self,out):
  print >> out, "Install action."

  atool=self.portal_actions
  aitool=self.portal_actionicons

  existing_actions=[a.id for a in atool._cloneActions()]
  if 'advanced_sendto' not in existing_actions:
    atool.addAction(id='advanced_sendto',
                    name='Send this page to specific users',
                    action='string:$object_url/choice_sendto_form?isurl=True',
                    condition='',
                    permission='MailServices: Use mailing services',
                    category='document_actions',
                    visible=1)

  if not aitool.queryActionIcon('plone','advanced_sendto'):
    aitool.addActionIcon(category='plone',
                         action_id='advanced_sendto',
                         icon_expr='icon_mail_services.png',
                         title='Mail services',
                         priority=0)

  print >>out, "Action was sucessfully installed"


def install_permissions(self,out):
  print >> out, "Install permissions"

  try:
    from Products.CMFCore.permissions import setDefaultRoles
  except ImportError:
    # for CMF 1.4
    from Products.CMFCore.CMFCorePermissions import setDefaultRoles
  portal_root=getToolByName(self,'portal_url').getPortalObject()

  ARMSperm = "MailServices: Use mailing services"

  # Set up default roles for permissions
  setDefaultRoles(ARMSperm, ('Manager',))
  # Don't know why, but the precedent line added permission, but didn't set role, so ...
  portal_root.manage_permission(ARMSperm, ('Manager',), False)

  print >>out, "Permissions was sucessfully added"


def install(self):
  out = StringIO()

  
  install_subskin(self, out, GLOBALS)

  #register armail_tool with the plone site
  if not hasattr(self, 'armail_tool'):
    addTool = self.manage_addProduct[PROJECTNAME].manage_addTool
    addTool('ARMail Tool')

  #install portlet
  #actual_slots = list(self.right_slots)
  #my_slot = 'here/portlet_mailservices/macros/portlet'
  #if my_slot not in actual_slots:
  #  actual_slots.append(my_slot)
  #  self.right_slots = tuple(actual_slots)
  #out.write('Portlets installed.\n')

  #install the stylesheets
  registerStylesheets(self, out, STYLESHEETS)

  #install permissions
  install_permissions(self,out)

  #install action
  install_actions(self,out)

  print >> out, "Successfully installed %s." % PROJECTNAME
  print out.getvalue()

def uninstall_actions(self):
    atool=self.portal_actions
    aitool=self.portal_actionicons

    existing_actions=[a.id for a in atool._cloneActions()]
    if 'advanced_sendto' in existing_actions:
        atool.deleteActions([existing_actions.index('advanced_sendto')])

    if aitool.queryActionIcon('plone','advanced_sendto'):
        aitool.removeActionIcon('plone','advanced_sendto')


def uninstall(self):
  out = StringIO()

  # uninstall actions and co.
  uninstall_actions(self)

  print >> out, "Successfully uninstalled %s." % PROJECTNAME
  return out.getvalue()
